const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const menuService = require('./menu.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/get-menu-hierarchy', authorize(), getMenuHierarchy);
router.post('/option', authorize(), option);
router.post('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

function create(req, res, next) {
    menuService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function getAll(req, res, next) {
    menuService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function getMenuHierarchy(req, res, next) {
    menuService.getMenuHierarchy(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function option(req, res, next) {
    menuService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function count(req, res, next) {
    menuService.count(req.body)
        .then(result => res.json(result))
        .catch(next);
}

function update(req, res, next) {
    menuService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function enabled(req, res, next) {
    menuService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

function _delete(req, res, next) {
    menuService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
